From 71893f00e2afa9a2b8c3c2e2b417effabfa8a97e Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 10 2017 15:10:50 +0000
Subject: [PATCH 746/1001] Sort the widget registry by name


The order in the configuration will be the order in which widgets will
be proposed for addition in a hub.

---

diff --git a/hubs/widgets/registry.py b/hubs/widgets/registry.py
index fe32607..f6e772b 100644
--- a/hubs/widgets/registry.py
+++ b/hubs/widgets/registry.py
@@ -1,19 +1,17 @@
 from __future__ import unicode_literals
 
-import six
-
+from collections import OrderedDict
 from importlib import import_module
-from six.moves import UserDict
 from hubs.widgets.base import Widget
 
 
-class WidgetRegistry(UserDict):
+class WidgetRegistry(OrderedDict):
     """
     The widget registry.
 
-    It behaves like a dictionary where widget names are keys and widget class
-    instances are values.  There are additional methods to register widgets and
-    widget-specific routes.
+    It behaves like an ordered dictionary where widget names are keys and
+    widget class instances are values.  There are additional methods to
+    register widgets and widget-specific routes.
 
     Widgets are registered using their class path in the following format:
     `python.path.to.module:TheWidgetClass`.
@@ -61,7 +59,7 @@ class WidgetRegistry(UserDict):
         except AttributeError as e:
             raise AttributeError(
                 "Error registering %s: %s" % (widget_path, e))
-        self.data[widget.name] = widget
+        self[widget.name] = widget
 
     def register_routes(self, app):
         """
@@ -76,8 +74,3 @@ class WidgetRegistry(UserDict):
         """
         for widget in self.values():
             widget.register_routes(app)
-
-    # IterableUserDict is in Python2 but not exported by six.
-    if six.PY2:
-        def __iter__(self):
-            return iter(self.data)

